HORRIBLE - Horrible Queries


World is getting more evil and it's getting tougher to get into the Evil League of Evil. Since the legendary Bad Horse has retired, now you have to correctly answer the evil questions of Dr. Horrible, who has a PhD in horribleness (but not in Computer Science). You are given an array of N elements, which are initially all 0. After that you will be given C commands. They are -

* 0 p q v - you have to add v to all numbers in the range of p to q (inclusive), where p and q are two indexes of the array.

* 1 p q - output a line containing a single integer which is the sum of all the array elements between p and q (inclusive)

 

Input

In the first line you'll be given T, number of test cases.

Each test case will start with N (N <= 100 000) and C (C <= 100 000). After that you'll be given C commands in the format as mentioned above. 1 <= p, q <= N and 1 <= v <= 10^7.

Output

Print the answers of the queries.

Example

Input:
1
8 6
0 2 4 26
0 4 8 80
0 4 5 20
1 8 8
0 5 7 14
1 4 8

Output:
80
508

hide comments
leductoan: 2019-07-30 10:01:43

AC in one GO

aryan29: 2019-07-10 21:43:31

I am doing everything right making array of 4*n making it zero after each test case using segment trees and lazy propog running good on tc on spoj toolkit still getting wa

mgroovyank: 2019-06-22 09:06:47

Hurray! 100th on Spoj!

shreyansh_02: 2019-06-20 08:34:16

why is O(N) solution not getting accepted ?
it is giving tle

Last edit: 2019-06-20 08:34:34
prudhvi_495: 2019-06-16 11:30:36

I solved this by taking the array size as 4 * n + 1. Can anyone tell me why 2 * nextpowerof2(n) - 1 is giving wrong answer.

sky_scraper: 2019-06-08 19:39:18

@batyr Don't build the tree initially directly update the values as all the values are zero initially.

batyr: 2019-05-29 08:18:39

why do I have TLE??
<snip>
Can anyone help me?

Last edit: 2022-10-17 21:58:41
indsonu: 2019-05-26 02:39:42

anyone can explain the second test case

harshraj22aug: 2019-05-07 05:55:00

<snip>, by the way , anyone has any idea how to solve it using binary search ?

Last edit: 2022-10-17 21:58:49
asfd: 2019-04-12 05:24:26

Why should array size be 4*n instead of pow(ceil(log2(n)+1) ?


Added by:Iqram Mahmud
Date:2010-12-04
Time limit:2.329s
Source limit:50000B
Memory limit:1536MB
Cluster: Cube (Intel G860)
Languages:All except: ASM64
Resource:Own. Thanks to Emir Habul.